#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define DEFAULT 2
#define TRUE 1
#define FALSE 0
#define UNDEFINED -1
#define XOR ^

#define BACKGROUND clSilver
#define WHITE (Graphics::TColor)0x00FFFFFF
#define BLACK clBlack
#define GRAY clGray
#define DARKGRAY clDkGray
#define RED clRed
#define YELLOW clYellow
#define GREEN clGreen
#define BLUE clBlue

TColor PixColor,
       Background = BACKGROUND,
       BoarderColor;

short Boarder = UNDEFINED;


#define PI 3.14159
#undef RAND_MAX
#define RAND_MAX 65536
#define FOREVER for(;;)
#define stccpy strncpy

float XLeft,
      XRight,
      XSize,
      YDown,
      YSize,
      YUp,
      Winheight,
      Winwidth;

FILE *In,
     *Out;

unsigned long Last_random = 1000;

short GraphicMode;

int Pen_x,
    Pen_y;

TColor Background_colour = clBtnFace;

void Clear_area()
{
  TRect NewRect = Rect( 1, 1, Winwidth, Winheight );
  Form1 -> SimArea -> Canvas -> Brush -> Color = Background_colour;
  Form1 -> SimArea -> Canvas -> FillRect( NewRect );
}

void Coordinates( float x_left, float y_down, float x_right, float y_up )
{
 XLeft = x_left;
 YDown = y_down;
 XRight = x_right;
 YUp = y_up;
 XSize = XRight - XLeft;
 YSize = YUp - YDown;
 Winwidth = Form1 -> SimArea -> Width;
 Winheight = Form1 -> SimArea -> Height;
}

void Filled_circle_2d( float left, float down, float right, float up,
                       TColor fill, TColor boarder )
{
 int left_win,
     down_win,
     right_win,
     up_win;

 left_win = (int)( ( left - XLeft ) / XSize * Winwidth ) - 1;
 down_win = Winheight - (int)(( down - YDown ) / YSize * Winheight ) + 1;
 right_win = (int)( ( right - XLeft ) / XSize * Winwidth ) + 1;
 up_win = Winheight - (int)(( up - YDown ) / YSize * Winheight ) - 1;
 Form1 -> SimArea -> Canvas -> Brush -> Color = fill;

 Form1 -> SimArea -> Canvas -> Pen -> Color = boarder;
 Form1 -> SimArea -> Canvas -> Ellipse( left_win, down_win, right_win, up_win );
}

Rnd()
{
 Last_random = ( (long)Last_random * 31991 + 11 ) % RAND_MAX;
 return( Last_random );
}

/* The following code has been downloaded */
/* Copyright (C) 1997 Makoto Matsumoto and Takuji Nishimura.       */
/* When you use this, send an email to: matumoto@math.keio.ac.jp   */
/* with an appropriate reference to your work.                     */

//  #include<stdio.h>

/* Period parameters */
#define NUM1 624
#define NUM2 397
#define MATRIX_A 0x9908b0df   /* constant vector a */
#define UPPER_MASK 0x80000000 /* most significant w-r bits */
#define LOWER_MASK 0x7fffffff /* least significant r bits */

/* Tempering parameters */
#define TEMPERING_MASK_B 0x9d2c5680
#define TEMPERING_MASK_C 0xefc60000
#define TEMPERING_SHIFT_U(y)  (y >> 11)
#define TEMPERING_SHIFT_S(y)  (y << 7)
#define TEMPERING_SHIFT_T(y)  (y << 15)
#define TEMPERING_SHIFT_L(y)  (y >> 18)

static unsigned long mt[NUM1]; /* the array for the state vector  */
static int mti=NUM1+1; /* mti==NUM1+1 means mt[NUM1] is not initialized */

/* initializing the array with a NONZERO seed */
void Start_random_gen( unsigned long seed)
{
    /* setting initial seeds to mt[NUM1] using         */
    /* the generator Line 25 of Table 1 in          */
    /* [KNUTH 1981, The Art of Computer Programming */
    /*    Vol. 2 (2nd Ed.), pp102]                  */
    mt[0]= seed & 0xffffffff;
    for (mti=1; mti<NUM1; mti++)
        mt[mti] = (69069 * mt[mti-1]) & 0xffffffff;
}

double /* generating reals */
/* unsigned long */ /* for integer generation */
Random_float()
{
    unsigned long y;
    static unsigned long mag01[2]={0x0, MATRIX_A};
    /* mag01[x] = x * MATRIX_A  for x=0,1 */

    if (mti >= NUM1) { /* generate NUM1 words at one time */
        int kk;

        if (mti == NUM1+1)   /* if sgenrand() has not been called, */
            Start_random_gen(4357); /* a default initial seed is used   */

        for (kk=0;kk<NUM1-NUM2;kk++) {
            y = (mt[kk]&UPPER_MASK)|(mt[kk+1]&LOWER_MASK);
            mt[kk] = mt[kk+NUM2] ^ (y >> 1) ^ mag01[y & 0x1];
        }
        for (;kk<NUM1-1;kk++) {
            y = (mt[kk]&UPPER_MASK)|(mt[kk+1]&LOWER_MASK);
            mt[kk] = mt[kk+(NUM2-NUM1)] ^ (y >> 1) ^ mag01[y & 0x1];
        }
        y = (mt[NUM1-1]&UPPER_MASK)|(mt[0]&LOWER_MASK);
        mt[NUM1-1] = mt[NUM2-1] ^ (y >> 1) ^ mag01[y & 0x1];

        mti = 0;
    }

    y = mt[mti++];
    y ^= TEMPERING_SHIFT_U(y);
    y ^= TEMPERING_SHIFT_S(y) & TEMPERING_MASK_B;
    y ^= TEMPERING_SHIFT_T(y) & TEMPERING_MASK_C;
    y ^= TEMPERING_SHIFT_L(y);

//    return ( (double)y / (unsigned long)0xffffffff ); /* reals */
    return ( (double)y / (double)0xffffffff ); /* reals */
    /* return y; */ /* for integer generation */
}


/*
float Random_float()
{
 float number;

 Rnd();
 number = (float)Last_random / (float)RAND_MAX;
 return(number);
}

void Start_random_gen( long seed )
{
 Last_random = seed;
}
*/

